from drivers import BaseDriver
import eip
import datetime
from collections import deque
import string

class CIP(BaseDriver):
	def __init__(self, cfg):
		self.tags = {}
		self.client = eip.PLC()
		self.client.IPAddress = cfg['IP']
		self.tags = {}
		self.comm_active = False
		self.read_queue = deque()
		self.write_queue = deque()
	def read(self, tag):
		result = None
		#print tag
		if tag in self.tags:
			result = self.tags[tag]
		
		if tag not in self.read_queue:
			self.read_queue.append(tag)
		
		
		return {tag: result}
	
	def write(self, tag, value):
		self.write_queue.append([tag, value])
		#self.client.Write(tag, value)

	def single_read(self, read_list=None):
		if read_list is None:
			read_list = list(self.read_queue)
			self.read_queue.clear()
		for tag in read_list:
			value = self.client.Read(tag)
			self.tags[tag] = value
	
	def bulk_read(self, read_list=None):
		if read_list is None:
			read_list = list(self.read_queue)
			self.read_queue.clear()
		
		if len(read_list) > 1:
			print "reading multiple"
			values = self.client.Read(read_list)
			for x in xrange(len(read_list)):
				self.tags[read_list[x]] = values[x]
		else:
			print "reading single"
			self.single_read(read_list)
			
	
	def tick(self, driverlist):
                if self.read_queue:
		    self.bulk_read()
		
		write_list = list(self.write_queue)
		self.write_queue.clear()
		for tag, value in write_list:
			self.client.Write(tag, value)
